package com.engine.dzfcd.service.impl;

import com.engine.core.impl.Service;
import com.engine.kq.biz.KQLeaveRulesComInfo;
import com.wbi.util.Util;
import com.engine.dzfcd.service.LeaveService;
import com.engine.dzfcd.util.DzUtil;
import org.apache.commons.lang3.StringUtils;
import weaver.general.BaseBean;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LeaveServiceImpl extends Service implements LeaveService {

    BaseBean bb = new BaseBean();
    @Override
    public Map<String, Object> checkLeaveInt(Map<String, Object> params) {

        Map<String, Object> result = new HashMap<>();

        bb.writeLog("params", params);

        String leaveType = Util.null2String(params.get("leaveType"));
        bb.writeLog("leaveType", leaveType);
        String resourceId = Util.null2String(params.get("resourceId"));
        bb.writeLog("resourceId", resourceId);

        if (StringUtils.isBlank(leaveType)) {
            result.put("code","500");
            result.put("msg","请先选择请假类型");
            return result;
        }

        if (StringUtils.isBlank(resourceId)) {
            result.put("code","500");
            result.put("msg","请先选择请假人员");
            return result;
        }

        KQLeaveRulesComInfo kqLeaveRulesComInfo = new KQLeaveRulesComInfo();

        //确认假期类型是否需要考虑前置假期余额
        DzUtil dzUtil = new DzUtil();
        List<String> beforeLeaveTypes = dzUtil.getBeforeLeaveTypes(leaveType);

        if (beforeLeaveTypes != null && beforeLeaveTypes.size() > 0 ) {
            for (String beforeLeave: beforeLeaveTypes) {
                //获取假期余额
                Map<String, Object> getParams = new HashMap<>();
                getParams.put("newLeaveType", beforeLeave);
                getParams.put("resourceId", resourceId);
                Map<String, Object> vacationInfo = dzUtil.getVacationInfo(getParams, user);
                if (vacationInfo.get("status").equals("1")) {
                    double doubleValue = Util.getDoubleValue(Util.null2String(vacationInfo.get("vacationInfo")));
                    if (doubleValue > 0.00) {
                        result.put("code","500");
                        result.put("msg",kqLeaveRulesComInfo.getLeaveName(beforeLeave) + "还有余额，请优先申请" + kqLeaveRulesComInfo.getLeaveName(beforeLeave));
                        return result;
                    }
                }
            }
        }
        result.put("code","200");
        result.put("msg","可以申请");
        return result;
    }




}
