package com.engine.dzfcd.util;

import com.engine.kq.biz.KQBalanceOfLeaveBiz;
import com.engine.kq.biz.KQLeaveRulesBiz;
import com.engine.kq.biz.KQLeaveRulesComInfo;
import com.engine.kq.cmd.attendanceEvent.AttendanceUtil;
import com.engine.kq.wfset.util.SplitSelectSet;
import com.wbi.util.Util;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class DzUtil {

    /**
     * 根据假期类型获取所有前置假期类型
     */
    public List<String> getBeforeLeaveTypes(String leaveType){
        RecordSet rs = new RecordSet();
        List<String> list = new ArrayList<String>();
        if(StringUtils.isNotBlank(leaveType)){
            String sql = " select beforLeaveType from uf_leaveIntro where leaveType = "+leaveType;
            rs.executeQuery(sql);
            while (rs.next()){
                String id = Util.null2String(rs.getString("beforLeaveType"));
                list.add(id);
                addBeforeLeave(list,id);
            }
        }

        return list;
    }

    public void addBeforeLeave(List<String> datasList, String parentid){

        String sql = " select beforLeaveType from uf_leaveIntro where leaveType="+parentid;
        List<Map<String,Object>> dataList = new ArrayList<>();
        RecordSet rs = new RecordSet();
        rs.execute(sql);
        while(rs.next()){
            String id = Util.null2String(rs.getString("beforLeaveType"));
            if(!datasList.contains(id)){
                datasList.add(id);
            }
            addBeforeLeave(datasList,id);
        }
    }

    /**
     * 根据人员和假期类型查询假期余额
     */
    public Map<String, Object> getVacationInfo(Map<String, Object> params, User user) {
        Map<String, Object> retmap = new HashMap<String, Object>();
        RecordSet rs = new RecordSet();
        String sql = "";
        String balanceOfLeave = "";
        try{
            //正式系统需要的
            String isFormal = weaver.general.Util.null2String(new BaseBean().getPropValue("kq_flow_formal", "isFormal"),"0");
            String newLeaveType = weaver.general.Util.null2String(params.get("newLeaveType"));
            String resourceId = weaver.general.Util.null2String(params.get("resourceId"));
            String fromDate = weaver.general.Util.null2String(params.get("fromDate"));
            String fromTime = weaver.general.Util.null2String(params.get("fromTime"));
            String toTime = weaver.general.Util.null2String(params.get("toTime"));
            boolean balanceEnable = KQLeaveRulesBiz.getBalanceEnable(newLeaveType);
            KQLeaveRulesComInfo leaveRulesComInfo = new KQLeaveRulesComInfo();
            boolean needClear = needClear(newLeaveType,leaveRulesComInfo,fromTime,toTime);
            if(balanceEnable){
                if(fromDate.length() == 0){
                    fromDate = DateUtil.getCurrentDate();
                }
                if("1".equalsIgnoreCase(isFormal)){
                    fromDate = DateUtil.getCurrentDate();
                }
                balanceOfLeave = KQBalanceOfLeaveBiz.getRestAmount(resourceId, newLeaveType, fromDate);
                String minimumUnit = leaveRulesComInfo.getMinimumUnit(newLeaveType);

                String minimumUnitName = KQLeaveRulesBiz.getMinimumUnitName(minimumUnit,user.getLanguage());
                String approvalInfo = "";
                double d_duration = AttendanceUtil.getFreezeDuration(newLeaveType,resourceId);
                if(d_duration > 0){
                    approvalInfo = "("+ SystemEnv.getHtmlLabelName(19134, user.getLanguage())+d_duration+minimumUnitName+")";
                }
                retmap.put("vacationInfo",SystemEnv.getHtmlLabelName(10000809,weaver.general.Util.getIntValue(user.getLanguage()))+balanceOfLeave+minimumUnitName+approvalInfo);
//                if(show_split_balance()){
                    String vacationInfo = "";
                    String allRestAmount = KQBalanceOfLeaveBiz.getRestAmount("" + resourceId, newLeaveType, fromDate, true);
//                    String currentRestAmount = KQBalanceOfLeaveBiz.getRestAmount("" + resourceId, newLeaveType, fromDate,false);

                    double doubleValue = Util.getDoubleValue(Util.null2String(allRestAmount));
                    vacationInfo = String.valueOf(doubleValue >= 0? doubleValue: 0.00 - d_duration);
                    retmap.put("vacationInfo",vacationInfo);
//                }
                retmap.put("status", "1");
            }else{
                //没有休假信息的
                retmap.put("status", "2");
            }
            if(needClear){
                retmap.put("needClear", "1");
            }else{
                retmap.put("needClear", "0");
            }

        }catch (Exception e) {
            retmap.put("status", "-1");
            retmap.put("message",  SystemEnv.getHtmlLabelName(382661,user.getLanguage()));

        }
        return retmap;
    }

    public boolean needClear(String newLeaveType,
                             KQLeaveRulesComInfo leaveRulesComInfo, String fromTime, String toTime) {
        boolean needClear = false;
        String minimumUnit = leaveRulesComInfo.getMinimumUnit(newLeaveType);
        String timeselection = leaveRulesComInfo.getTimeSelection(newLeaveType);

        if(!"2".equalsIgnoreCase(timeselection)){
            if("2".equalsIgnoreCase(minimumUnit)){
                if(fromTime.equalsIgnoreCase(SplitSelectSet.forenoon_start) || fromTime.equalsIgnoreCase(SplitSelectSet.forenoon_end)){
                    //表示不清空
                }else{
                    needClear = true;
                }
                if(!needClear){
                    if(toTime.equalsIgnoreCase(SplitSelectSet.afternoon_start) || toTime.equalsIgnoreCase(SplitSelectSet.afternoon_end)){
                        //表示不清空
                    }else{
                        needClear = true;
                    }
                }
            }else if("4".equalsIgnoreCase(minimumUnit)){
                if(fromTime.equalsIgnoreCase(SplitSelectSet.daylong_start)){
                    //表示不清空
                }else{
                    needClear = true;
                }
                if(!needClear){
                    if(toTime.equalsIgnoreCase(SplitSelectSet.daylong_end)){
                        //表示不清空
                    }else{
                        needClear = true;
                    }
                }
            }
        }
        return needClear;
    }

    /**
     * 建模权限重构
     * @param billid_creator
     * @param modeId
     * @param billids
     */
    public void modePerReconBatch(Map<Integer,Integer> billid_creator, String modeId, List<Integer> billids) {
        ModeRightInfo ModeRightInfo = new ModeRightInfo();
        ModeRightInfo.setNewRight(true);
        ModeRightInfo.editModeDataShare( billid_creator, Integer.parseInt(modeId), billids);
    }

}
